﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace MvcSettings.Caching
{
    public interface IOutputCacheManager
    {
        IEnumerable<OutputCacheItem> CacheItems { get; }
        object Get(string cacheKey);
        void Store(string cacheKey, object value, bool sliding, int secondsToCache);
        string GenerateCacheKey(ActionExecutingContext context);
        void Remove(string cacheKey);
        void Clear();
        void Clear(string controllerName);
        void Clear(string actionName, string controllerName);
        void Clear(string actionName, string controllerName, object routeValues);
    }
}