﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Caching;

namespace MvcSettings.Caching
{
    public class NullCache : ICache
    {
        public IDictionary<string, object> Values
        {
            get { return new Dictionary<string, object>(); }
        }

        public IEnumerable<string> Keys
        {
            get { return new List<string>(); }
        }

        public object Get(string key)
        {
            return null;
        }

        public void Store(string key, object value, int secondsToCache)
        {
        }

        public void Remove(string key)
        {
        }

        public void Clear()
        {
        }

        public void Store(string key, object value, bool sliding, int secondsToCache)
        {
        }

        public int MaxDuration
        {
            get { return 0;  }
        }
    }
}