﻿using Autofac;
using MvcSettings.Caching;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Autofac.Integration.Mvc;

namespace MvcSettings.Services
{
    public enum CacheType
    {
        Local,
        Azure,
        None
    }

    public class CacheModule : Module
    {
        public CacheType CacheType { get; set; }

        protected override void Load(ContainerBuilder builder)
        {
            builder.RegisterType<OutputCacheManager>().As<IOutputCacheManager>();
            //builder.Register(c => new CacheOnServerAttribute(c.Resolve<IOutputCacheManager>()))
            //       .AsActionFilterFor<Controller>().InstancePerRequest();

            //builder.RegisterFilterProvider();

            if (CacheType == CacheType.Local)
            {
                builder.RegisterType<AspNetCache>().As<ICache>().InstancePerRequest();
            }
            else if (CacheType == CacheType.Azure)
            {
                builder.RegisterType<AzureCache>().As<ICache>().InstancePerRequest();
            }
            else
            {
                builder.RegisterType<NullCache>().As<ICache>().InstancePerRequest();
            }
        }
    }
}